/*
	$Id: SCSerikoSeqPatternEntry.java,v 1.2 2002/12/08 16:10:06 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSerikoSeqPatternEntry
    
    patternGg̃f[^\܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCSerikoSeqPatternEntry
{
    // p[^́AgȂ\bhłꍇ͏0ƂȂ܂B
    // I^ieBuX^[g̃GgXgȂnullɂȂ܂B
    
    // {p[^
    int surfaceid;
    int interval;
    String method;
    int offsetx,offsety;
    
    // startp
    int seq_id;
    
    // alternativestartp
    Vector entries; // gIntegerB
    
    // insertp
    int bind_id;
    
    public SCSerikoSeqPatternEntry(String dataline)
    {
		/*
			datalineɂ́A[seqid]pattern[index],̌̃f[^w肵ĉB
			
			Ⴆ΁A
			1pattern0,50,20,overlay,10,0
			
			50,20,overlay,10,0
			łB
		*/
		StringTokenizer st = new StringTokenizer(dataline,",");
		
		// surfaceidinterval̃tB[h́AႦ0ŃpfBOĂɂK݂B
		try{ surfaceid = Integer.parseInt(st.nextToken()); }catch(Exception e){}
		try{ interval = Integer.parseInt(st.nextToken()); }catch(Exception e){}
		method = st.nextToken();
		
		// methodɏ]Aǉf[^ǂݍށB
		if (method.equals("start"))
		{
			try{ seq_id = Integer.parseInt(st.nextToken()); }catch(Exception e){}
		}
		else if (method.equals("insert"))
		{
			try{ bind_id = Integer.parseInt(st.nextToken()); }catch(Exception e){}
		}
		else if (method.equals("alternativestart"))
		{
			String altana_param = st.nextToken();
			String entry_list = altana_param.substring(1, altana_param.length() - 1); // O̊ʂ
			
			entries = new Vector();
			StringTokenizer ent_st = new StringTokenizer(entry_list,".");
			int n_entries = ent_st.countTokens();
			for (int i = 0;i < n_entries;i++)
			{
				try{ entries.add(new Integer( ent_st.nextToken() )); }catch(Exception e){}
			}
		}
		else
		{
			try{ offsetx = Integer.parseInt(st.nextToken()); }catch(Exception e){}
			try{ offsety = Integer.parseInt(st.nextToken()); }catch(Exception e){}
		}
    }
    
    public void dump()
    {
		System.out.println(surfaceid+","+interval+","+method+","+offsetx+","+offsety);
    }
    
    public int surfaceid()
    {
		return surfaceid;
    }
    
    public int interval()
    {
		return interval;
    }
    
    public String method()
    {
		return method;
    }
    
    public int offsetx()
    {
		return offsetx;
    }
    
    public int offsety()
    {
		return offsety;
    }
    
    public int seq_id()
    {
		return seq_id;
    }
    
    public Vector entries()
    {
		return entries;
    }
    
    public int bind_id()
    {
		return bind_id;
    }
}
